'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * Component responsible for containg the Items and styling the container/grid
 *
 * PropTypes:
 *  - columnCount: Indicates the number of columns that the grid will have
 *  - gutterSize: Indicates, in vw, the size of the interval between Items
 *  - children: A react node, it should ideally be an array of Items but the
 *              user is free to do whatever :)
 */
var Grid = function (_PureComponent) {
  _inherits(Grid, _PureComponent);

  function Grid() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Grid);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Grid.__proto__ || Object.getPrototypeOf(Grid)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      style: { display: 'none' }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Grid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          columnCount = _props.columnCount,
          gutterSize = _props.gutterSize,
          context = this.context;

      var _context$squarelyMana = context.squarelyManager.subscribeGrid(function (style) {
        return _this2.setState({ style: style });
      }),
          update = _context$squarelyMana.update,
          unsubscribe = _context$squarelyMana.unsubscribe;

      update({ columnCount: columnCount, gutterSize: gutterSize });

      this.update = update;
      this.unsubscribe = unsubscribe;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref2) {
      var columnCount = _ref2.columnCount,
          gutterSize = _ref2.gutterSize;
      var props = this.props;


      if (props.columnCount !== columnCount || props.gutterSize !== gutterSize) {
        this.update({ columnCount: columnCount, gutterSize: gutterSize });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unsubscribe();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { style: this.state.style },
        this.props.children
      );
    }
  }]);

  return Grid;
}(_react.PureComponent);

Grid.propTypes = {
  columnCount: _propTypes2.default.number.isRequired,
  gutterSize: _propTypes2.default.number.isRequired,
  children: _propTypes2.default.node
};
Grid.defaultProps = {
  columnCount: 2,
  gutterSize: 0.5
};
Grid.contextTypes = {
  squarelyManager: _propTypes2.default.shape({
    subscribeGrid: _propTypes2.default.func.isRequired
  }).isRequired
};
exports.default = Grid;
//# sourceMappingURL=index.js.map