'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * Component responsible for configuring each item in the grid
 *
 * PropTypes:
 *  - origin: Object with keys column and row, which indicates the origin point
 *            of the item (starts at 1).
 *  - column: Object with keys column and row, which indicates the number of
 *            columns and rows that this item spans
 *  - children: React node, meaning whatever the user wants
 */
var Item = function (_PureComponent) {
  _inherits(Item, _PureComponent);

  function Item() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Item);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Item.__proto__ || Object.getPrototypeOf(Item)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      style: { display: 'none' }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Item, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          origin = _props.origin,
          span = _props.span,
          context = this.context;

      var _context$squarelyMana = context.squarelyManager.subscribeItem(function (style) {
        return _this2.setState({ style: style });
      }),
          update = _context$squarelyMana.update,
          unsubscribe = _context$squarelyMana.unsubscribe;

      update({ origin: origin, span: span });

      this.update = update;
      this.unsubscribe = unsubscribe;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref2) {
      var origin = _ref2.origin,
          span = _ref2.span;
      var props = this.props;


      if (origin.column !== props.origin.column || origin.row !== props.origin.row || span.column !== props.span.column || span.row !== props.span.row) {
        this.update({ origin: origin, span: span });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unsubscribe();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { style: this.state.style },
        this.props.children
      );
    }
  }]);

  return Item;
}(_react.PureComponent);

Item.propTypes = {
  origin: _propTypes2.default.shape({
    column: _propTypes2.default.number.isRequired,
    row: _propTypes2.default.number.isRequired
  }).isRequired,
  span: _propTypes2.default.shape({
    column: _propTypes2.default.number.isRequired,
    row: _propTypes2.default.number.isRequired
  }).isRequired,
  children: _propTypes2.default.node
};
Item.contextTypes = {
  squarelyManager: _propTypes2.default.shape({
    subscribeItem: _propTypes2.default.func.isRequired
  }).isRequired
};
exports.default = Item;
//# sourceMappingURL=index.js.map