'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cssElementQueries = require('css-element-queries');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * Root component of them all, it has the responsibility of setting the manager
 * in context, and also to check for any size changes in the container, so that
 * it can update the manager.
 *
 * PropTypes:
 *  - manager: Instance of *Manager, which has the responsibility in managing
 *             Grid and Items styles
 *  - children: React node, expecting Grid
 */
var Provider = function (_PureComponent) {
  _inherits(Provider, _PureComponent);

  function Provider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Provider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Provider.__proto__ || Object.getPrototypeOf(Provider)).call.apply(_ref, [this].concat(args))), _this), _this.handleResize = function () {
      return _this.props.manager.setContainerWidth(_this.container.offsetWidth);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Provider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return { squarelyManager: this.props.manager };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.handleResize();

      this.resizeSensor = new _cssElementQueries.ResizeSensor(this.container, this.handleResize);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.resizeSensor.detach(this.container, this.handleResize);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        { ref: function ref(container) {
            return _this2.container = container;
          } },
        this.props.children
      );
    }
  }]);

  return Provider;
}(_react.PureComponent);

Provider.propTypes = {
  manager: _propTypes2.default.shape({
    setContainerWidth: _propTypes2.default.func.isRequired
  }).isRequired,
  children: _propTypes2.default.node.isRequired
};
Provider.childContextTypes = {
  squarelyManager: _propTypes2.default.object.isRequired
};
exports.default = Provider;
//# sourceMappingURL=index.js.map