'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Grid = exports.Item = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Item = require('./Item');

Object.defineProperty(exports, 'Item', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_Item).default;
  }
});

require('./utils/Modernizr');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Provider = require('./Provider');

var _Provider2 = _interopRequireDefault(_Provider);

var _Grid = require('./Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _CSSGridManager = require('./CSSGridManager');

var _CSSGridManager2 = _interopRequireDefault(_CSSGridManager);

var _CSSAbsoluteManager = require('./CSSAbsoluteManager');

var _CSSAbsoluteManager2 = _interopRequireDefault(_CSSAbsoluteManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * We create here a new component which mounts Provider and Grid to simplify usage
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * to the end user
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * The Manager used is dependent on the browser supporting CSS grid or not
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * If for some reason there's a need to use other managers just pass it as a props
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Grid = exports.Grid = function (_PureComponent) {
  _inherits(Grid, _PureComponent);

  function Grid() {
    var _ref;

    _classCallCheck(this, Grid);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = Grid.__proto__ || Object.getPrototypeOf(Grid)).call.apply(_ref, [this].concat(args)));

    _this.manager = new args[0].managerClass();
    return _this;
  }

  _createClass(Grid, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _Provider2.default,
        { manager: this.manager },
        _react2.default.createElement(_Grid2.default, this.props)
      );
    }
  }]);

  return Grid;
}(_react.PureComponent);

Grid.propTypes = {
  managerClass: _propTypes2.default.func.isRequired
};
Grid.defaultProps = {
  managerClass: window.Modernizr.cssgrid ? _CSSGridManager2.default : _CSSAbsoluteManager2.default
};
//# sourceMappingURL=index.js.map